Reinforcement BarShapeCutList

From FreeCAD Documentation
Revision as of 15:20, 3 September 2020 by Suraj Dadral (talk | contribs)

Reinforcement Bar Shape Cut List

Menu location
Reinforcement → RebarShapeCutList
Workbenches
Reinforcement, Arch, BIM
Default shortcut
None
Introduced in version
0.19
See also
BillOfMaterial

Description

The Rebar Shape Cut List tool allows the user to create rebar shape cut list of reinforcing bars.

This command is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager via the Tools → Addon manager → Reinforcement menu.

Rebar Shape Cut List of reinforcing bars

Usage

1. Select Arch Rebar and Rebar2 objects you want to include in Rebar Shape Cut List. Or select Arch Structure objects to include Arch Rebar and Rebar2 objects hosted by that into Rebar Shape Cut List. If nothing is selected, then Bill Of Material will be generated for all Arch Rebar and Rebar2 objects present in model.

2. Then select Rebar Shape Cut List from the rebar tools.

3. A dialog box will pop-out on screen as shown below.

Dialog Box for the Reinforcement Bar Shape Cut List tool

4. Modify data to suit your requirements.

5. Click OK or Apply to generate Rebar Shape Cut List for rebars.

6. Click Cancel to exit the dialog box.

Properties

General:

  • DataStirrup Extended Edge Offset: The offset of extended end edges of stirrup, so that end edges of stirrup with 90 degree bent angle do not overlap with stirrup edges.
  • DataRebars Stroke Width: The stroke-width of rebars in rebar shape cut list.
  • DataRebars Color Style: The color style of rebars.
  • DataRow Height: The height of each row of rebar shape in rebar shape cut list.
  • DataColumn Width: The width of each column of rebar shape in rebar shape cut list.
  • DataColumn Count: The number of columns in rebar shape cut list.
  • DataSide Padding: The padding on each side of rebar shape.
  • DataHorizontal Rebar Shape: If True, then rebar shape will be made horizontal by rotating max length edge of rebar shape.
  • DataInclude Mark: If it is set to True, then rebar.Mark will be included for each rebar shape in rebar shape cut list.
  • DataSVG Output File: The output file to write generated rebar shape cut list svg.

Dimension Data:

  • DataInclude Dimensions: If True, then each rebar edge dimensions and bent angle dimensions will be included in rebar shape cut list.
  • DataInclude Units in Dimension Label: If it is True, then rebar edge length units will be shown in dimension label.
  • DataRebar Edge Dimension Units: The units to be used for rebar edge length dimensions.
  • DataRebar Edge Dimension Precision: The number of decimals that should be shown for rebar edge length as dimension label.
  • DataDimension Font Family: The font-family of dimension text.
  • DataDimension Font Size: The font-size of dimension text.
  • DataBent Angle Dimension Exclude List: The list of bent angles to not include their dimensions.
  • DataHelical Rebar Dimension Label Format: The format of helical rebar dimension label. e.g. "%L,r=%R,pitch=%P" where %L -> Length of helical rebar, %R -> Helix radius of helical rebar, %P -> Helix pitch of helical rebar.

Scripting

See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.

The Rebar Shape Cut List tool can be used in macros and from the Python console by using the following function:

Create Rebar Shape SVG

getRebarShapeSVG(
    rebar,
    view_direction: Union[FreeCAD.Vector, WorkingPlane.Plane] = FreeCAD.Vector(0, 0, 0),
    include_mark: bool = True,
    stirrup_extended_edge_offset: float = 2,
    rebar_stroke_width: float = 0.35,
    rebar_color_style: str = "shape color",
    include_dimensions: bool = True,
    rebar_dimension_units: str = "mm",
    rebar_length_dimension_precision: int = 0,
    include_units_in_dimension_label: bool = False,
    bent_angle_dimension_exclude_list: Tuple[float, ...] = (45, 90, 180),
    dimension_font_family: str = "DejaVu Sans",
    dimension_font_size: float = 2,
    helical_rebar_dimension_label_format: str = "%L,r=%R,pitch=%P",
    scale: float = 1,
    max_height: float = 0,
    max_width: float = 0,
    side_padding: float = 1,
    horizontal_shape: bool = False,
) -> ElementTree.Element
  • Generates and return a rebar shape svg element for given rebar object.
  • view_direction specifies the view point direction for rebar shape. It can be of type FreeCAD.Vector or WorkingPlane.Plane though WorkingPlane.Plane is preferred.
  • include_mark specifies if rebar.Mark is to be included in rebar shape svg or not.
  • stirrup_extended_edge_offset is the offset of extended end edges of stirrup, so that end edges of stirrup with 90 degree bent angle do not overlap with stirrup edges.
  • rebar_stroke_width specifies the stroke-width of rebar in svg.
  • rebar_color_style specifies the color style of rebar. It can be "shape color" or "color_name or hex_value_of_color". "shape color" means select color of rebar shape.
  • include_dimensions specifies if each rebar edge dimensions and bent angle dimensions is to be included in rebar shape svg.
  • rebar_dimension_units specifies the units to be used for rebar length dimensions.
  • rebar_length_dimension_precision specifies the number of decimals that should be shown for rebar length as dimension label. Set it to None to use user preferred unit precision from FreeCAD unit preferences.
  • include_units_in_dimension_label specifies if rebar length units is to be shown in dimension label.
  • bent_angle_dimension_exclude_list specifies the list of bent angles to not include their dimensions.
  • dimension_font_family specifies the font-family of dimension text.
  • dimension_font_size specifies the font-size of dimension text.
  • helical_rebar_dimension_label_format specifies the format of helical rebar dimension label. E.g. "%L,r=%R,pitch=%P" where:
   %L -> Length of helical rebar
   %R -> Helix radius of helical rebar
   %P -> Helix pitch of helical rebar
  • scale specifies the scale value to scale rebar svg. The scale parameter helps to scale down rebar_stroke_width and dimension_font_size to make them resolution independent. If max_height or max_width is set to non-zero value, then scale parameter will be ignored.
  • max_height specifies the maximum height of rebar shape svg. Set it to 0 to have rebar shape svg height based on scale parameter.
  • max_width specifies the maximum width of rebar shape svg. Set it to 0 to have rebar shape svg width based on scale parameter.
  • side_padding specifies the padding on each side of rebar shape.
  • horizontal_shape specifies if rebar shape is to be made horizontal by rotating max length edge of rebar shape.

Example

from pathlib import Path
from xml.dom import minidom
from xml.etree import ElementTree

import Draft, Arch, Stirrup
from RebarShapeCutList import RebarShapeCutListfunc

Rect = Draft.makeRectangle(400, 400)
Structure = Arch.makeStructure(Rect, height=1600)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

Rebar = Stirrup.makeStirrup(
    20, 20, 20, 20, 20, 90, 4, 8, 2, True, 10, Structure, "Face6"
)

rebar_shape_svg = RebarShapeCutListfunc.getRebarShapeSVG(
    Rebar,
    view_direction=FreeCAD.Vector(0, 0, 0),
    include_mark=True,
    stirrup_extended_edge_offset=2,
    rebar_stroke_width=0.35,
    rebar_color_style="shape color",
    include_dimensions=True,
    rebar_dimension_units="mm",
    rebar_length_dimension_precision=0,
    include_units_in_dimension_label=True,
    bent_angle_dimension_exclude_list=(45, 90, 180),
    dimension_font_family="DejaVu Sans",
    dimension_font_size=2,
    helical_rebar_dimension_label_format="%L,r=%R,pitch=%P",
    scale=1,
    max_height=100,
    max_width=100,
    side_padding=1,
    horizontal_shape=False,
)

output_file = str(Path.home() / "StirrupRebarShape.svg")
with open(output_file, "w", encoding="utf-8") as f:
    f.write(
        minidom.parseString(
            ElementTree.tostring(rebar_shape_svg, encoding="unicode")
        ).toprettyxml(indent="  ")
    )